# Generated by Django 3.2.5 on 2023-03-01 10:00

from django.db import migrations, models
from financemodule.enum import ExchangeRateCurrency , ExchangeMidrate 



def create_exchangerates(apps, schema_editor):
    exchange_rate = apps.get_model("financemodule.Exchangerate")
    db_alias = schema_editor.connection.alias
    exchange_rate.objects.using(db_alias).bulk_create([
    exchange_rate(rate_currency = ExchangeRateCurrency.SGD.value, rate_mid = ExchangeMidrate.SGD_RATE.value),
    exchange_rate(rate_currency = ExchangeRateCurrency.HKD.value,  rate_mid = ExchangeMidrate.HKD_RATE.value),
    exchange_rate(rate_currency = ExchangeRateCurrency.CNY.value,  rate_mid = ExchangeMidrate.CNY_RATE.value),
    exchange_rate(rate_currency = ExchangeRateCurrency.AED.value,  rate_mid = ExchangeMidrate.AED_RATE.value),
    exchange_rate(rate_currency = ExchangeRateCurrency.EUR.value,  rate_mid = ExchangeMidrate.EUR_RATE.value),
    exchange_rate(rate_currency = ExchangeRateCurrency.USD.value,  rate_mid = ExchangeMidrate.USD_RATE.value)])


class Migration(migrations.Migration):

    initial = True

    dependencies = [
    ]

    operations = [
        migrations.CreateModel(
            name='Exchangerate',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('bank_entity', models.IntegerField()),
                ('rate_base_currency', models.CharField(max_length=255)),
                ('rate_currency', models.CharField(max_length=255)),
                ('rate_date', models.DateField()),
                ('rate_previous_day', models.DateField()),
                ('rate_buy', models.FloatField()),
                ('rate_sell', models.FloatField()),
                ('rate_mid', models.FloatField()),
            ],
        ),
        migrations.RunPython(create_exchangerates),
        migrations.CreateModel(
            name='Finance',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('finance_id', models.CharField(max_length=55)),
                ('finance_date', models.DateField()),
                ('finance_request_id', models.IntegerField()),
                ('program_type', models.CharField(max_length=55)),
                ('anchor_party', models.IntegerField()),
                ('counterparty', models.IntegerField()),
                ('due_date', models.DateField()),
                ('invoice_currency', models.CharField(max_length=55)),
                ('invoice_amount', models.IntegerField()),
                ('finance_currency', models.CharField(max_length=55)),
                ('finance_amount', models.IntegerField()),
                ('settlement_currency', models.CharField(max_length=55)),
                ('settlement_amount', models.IntegerField()),
                ('repayment_acc_currency', models.CharField(max_length=55)),
                ('repayment_account', models.CharField(max_length=55)),
                ('interest_type', models.CharField(max_length=55)),
                ('interest_rate_type', models.CharField(max_length=55)),
                ('margin', models.FloatField()),
                ('interest_rate', models.FloatField()),
                ('interest_amount', models.IntegerField()),
                ('interest_paid_by', models.CharField(max_length=55)),
                ('own_party_account_info', models.CharField(max_length=55)),
                ('remittance_info', models.CharField(max_length=55)),
                ('status', models.CharField(max_length=55)),
                ('created_date', models.DateTimeField(auto_now_add=True)),
            ],
        ),
        migrations.CreateModel(
            name='FinanceAccounting',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('contract_ref', models.CharField(max_length=155)),
                ('stage', models.CharField(max_length=155)),
                ('type', models.CharField(max_length=155)),
                ('currency', models.CharField(max_length=155)),
                ('amount', models.IntegerField()),
                ('account', models.CharField(max_length=55)),
                ('account_type', models.CharField(max_length=155)),
                ('base_curreny', models.CharField(max_length=155)),
                ('base_currency_amount', models.IntegerField()),
                ('exch_rate', models.FloatField()),
                ('created_date', models.DateTimeField(auto_now_add=True)),
            ],
        ),
    ]
